#include "math.h"
#include "mex.h"
#include <stdlib.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{

//Declarations
mxArray *xData;
double *ima, *fima,*medias;
mxArray *pv;
double p,mindis,dis;
int i,j,k,ii,jj,kk,ni,nj,nk,c,ndim,label;
const int  *dims;

//Copy input pointer x
xData = prhs[0];

//Get matrix x
ima = mxGetPr(xData);

ndim = mxGetNumberOfDimensions(prhs[0]);
dims= mxGetDimensions(prhs[0]);

//Allocate memory and assign output pointer

//printf("ancho=%d\r",dims[0]);
//printf("alto=%d\r",dims[1]);
//printf("profundo=%d\r",dims[2]);

plhs[0] = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL);

//Get a pointer to the data space in our newly allocated memory
fima = mxGetPr(plhs[0]);

//precomputo de momentos de orden 1 y 2

for(k=0;k<dims[2];k++)
{
for(i=0;i<dims[1];i++)
{
  for(j=0;j<dims[0];j++)
  {
      if(ima[k*(dims[0]*dims[1])+(i*dims[0])+j]>0)
      {         
        fima[k*(dims[0]*dims[1])+(i*dims[0])+j]=ima[k*(dims[0]*dims[1])+(i*dims[0])+j];  
        
        for(ii=-1;ii<=1;ii++)
        for(jj=-1;jj<=1;jj++)
        {
            if(ii==0 && jj==0) continue; 
            ni=i+ii;
            nj=j+jj; 
            if(ni>=0 && ni<dims[1] && nj>=0 && nj<dims[0])
            {
                if(ima[k*(dims[0]*dims[1])+(i*dims[0])+j]!=ima[k*(dims[0]*dims[1])+(ni*dims[0])+nj])
                {
                    fima[k*(dims[0]*dims[1])+(i*dims[0])+j]=0;
                    break;
                }
            }
        }        
      }
      else fima[k*(dims[0]*dims[1])+(i*dims[0])+j]=0;
  }
}
}


return;

}

