function brainextract(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Extracts the brain from a MRI T1w volume 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning off;

%addpath e:\spm8
%addpath e:\spm8\toolbox\vbm8\
%addpath .\BrainExtraction

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(nargin==0)
  filename=spm_select;
end

disp('Loading data ...');

[path,name,ext]=fileparts(filename);
%cd ..
%resultspath=[pwd,'\results\',name,'\'];
%cd prototipo
fname=[name,ext];
%mkdir(resultspath)

V=spm_vol(filename);
ima=spm_read_vols(V);
ima=double(ima);

%************************************************
% Brain Extraction and biascorrection 
%************************************************

disp('Brain Extraction  ...');

[bima,label]=exbrain(V.fname);

% save data
label=double(label>0);
ima=ima.*label;

V.fname=[path,'\e_',fname];
spm_write_vol(V,ima);

V.fname=[path,'\mask_',fname];
spm_write_vol(V,label);

disp('Done!')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
