function nucorrect(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Correctcs Non Uniformity artifact in MRI T1w volume
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning off;

%addpath e:\spm8
%addpath e:\spm8\toolbox\vbm8\
%addpath .\BrainExtraction

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(nargin==0)
  filename=spm_select;
end

disp('Loading data ...');

[path,name,ext]=fileparts(filename);
%cd ..
%resultspath=[pwd,'\results\',name,'\'];
%cd prototipo
fname=[name,ext];
%mkdir(resultspath)

V=spm_vol(filename);
ima=spm_read_vols(V);
ima=double(ima);

%************************************************
% Biascorrection 
%************************************************

disp('Bias Correction ...');

[bima,label]=exbrain(V.fname);

% save data

V.fname=[path,'\m_',fname];
spm_write_vol(V,bima);

disp('Done!')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
