% Create volImage volume. 
function[volImage] = resizeVol(vol)

    global offsetx;
    global offsety;
    global offsetz;
    global ox;
    global oy;
    global fx;
    global fy;
    global maxSize;
   
    sizeLocal=size(vol);
    minSize=min(sizeLocal);
    maxSize=max(sizeLocal);
    

    offsetx=round((maxSize-sizeLocal(1))/2);
    offsety=round((maxSize-sizeLocal(2))/2);
    offsetz=round((maxSize-sizeLocal(3))/2);
    
    
    % New 3x3 matrix with the maxSize of original Volume.
    volImage=zeros(maxSize,maxSize,maxSize);
    

    if (offsetx == 0)
        ox=(offsetx+1);
    else
        if (mod(sizeLocal(1), 2) ~= 0)
            ox=offsetx;
        else
            ox=(offsetx+1);
        end
    end
    
    
    if (offsety == 0)
        oy=(offsety+1);
    else
        if (mod(sizeLocal(2), 2) ~= 0)
            oy=offsety;
        else
            oy=(offsety+1);
        end
    end


    fx=min((maxSize-offsetx), maxSize);
    fy=min((maxSize-offsety), maxSize);
        
    for i=1:sizeLocal(3)
        volImage(ox:fx,oy:fy,(i+offsetz))=vol(:,:,i);
    end